
Object subclass: #ConfigurationOfActalk
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfActalk'!

!ConfigurationOfActalk class methodsFor: 'development support' stamp: 'SergeStinckwich 11/22/2014 14:07'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfActalk class methodsFor: 'private' stamp: 'SergeStinckwich 11/22/2014 14:07'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfActalk class methodsFor: 'private' stamp: 'SergeStinckwich 11/22/2014 14:07'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfActalk class methodsFor: 'private' stamp: 'SergeStinckwich 11/22/2014 14:07'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfActalk class methodsFor: 'metacello tool support' stamp: 'SergeStinckwich 11/22/2014 14:07'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfActalk class methodsFor: 'loading' stamp: 'SergeStinckwich 11/22/2014 14:07'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfActalk class methodsFor: 'loading' stamp: 'SergeStinckwich 11/22/2014 14:07'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfActalk class methodsFor: 'loading' stamp: 'SergeStinckwich 11/22/2014 14:07'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfActalk class methodsFor: 'accessing' stamp: 'SergeStinckwich 11/22/2014 14:07'!
project

	^self new project! !

!ConfigurationOfActalk class methodsFor: 'development support' stamp: 'SergeStinckwich 11/22/2014 14:07'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfActalk methodsFor: 'baselines' stamp: 'SergeStinckwich 11/22/2014 14:10'!
baseline01: spec
	<version: '0.1-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://smalltalkhub.com/mc/SergeStinckwich/Actalk/main/'.
		spec package: 'Actalk'. ].
! !

!ConfigurationOfActalk methodsFor: 'accessing' stamp: 'SergeStinckwich 11/22/2014 14:07'!
customProjectAttributes
	 "Edit to return a collection of any custom attributes e.g. for conditional loading: Array with: #'Condition1' with: #'Condition2.
	For more information see: http://code.google.com/p/metacello/wiki/CustomProjectAttrributes"

	^ #().! !

!ConfigurationOfActalk methodsFor: 'symbolic versions' stamp: 'SergeStinckwich 11/22/2014 14:07'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '0.1-baseline'.
! !

!ConfigurationOfActalk methodsFor: 'accessing' stamp: 'SergeStinckwich 11/22/2014 14:07'!
project

	^ project ifNil: [ 
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		project := MetacelloMCProject new projectAttributes: self customProjectAttributes. 
		(Smalltalk at: #MetacelloVersionConstructor) on: self project: project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfActalk methodsFor: 'symbolic versions' stamp: 'SergeStinckwich 11/22/2014 14:13'!
stable: spec
	<symbolicVersion: #'stable'>

	spec for: #'common' version: '1.0'.
! !

!ConfigurationOfActalk methodsFor: 'versions' stamp: 'SergeStinckwich 11/22/2014 14:13'!
version10: spec
	<version: '1.0' imports: #('0.1-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'stable'.
		spec description: 'version 1.0'.
		spec author: 'SergeStinckwich'.
		spec timestamp: '11/22/2014 14:13'.
		spec package: 'Actalk' with: 'Actalk-zz.4'. ].
! !
